Subject: Re: xfrm, ip tunnel: non released device reference upon device unregistration

From: Eyal Birger <[email-masked]>
Date: Mon, 12 Feb 2018 13:54:39 +0200

On Sun, 11 Feb 2018 16:46:48 +0100
Florian Westphal <[email-masked]> wrote:

> Eyal Birger <[email-masked]> wrote:
> 
> Sorry for taking so long to respond.
> 
> > On Tue, 6 Feb 2018 14:15:09 +0100
> > Florian Westphal <[email-masked]> wrote:
> >   
> > > Steffen Klassert <[email-masked]> wrote:  
> > > > I gave the patch a quick try, but still I get this:
> > > > 
> > > > unregister_netdevice: waiting for dummy1 to become free. Usage
> > > > count = 2    
> > > 
> > > Was that with Eyals setup or the bridge one I posted?
> > > 
> > > If it was Eyals setup, its possible the patch missed hookup
> > > to whatever tunnel infra is used (the setup I used has ipip
> > > tunnel, everything is ipv4).
> > >   
> > 
> > Thanks!
> > 
> > Indeed the setup I'm testing uses ip6_tunnel.
> > I have tested a fix in the spirit of the patch and it looks valid 
> > for ip6_tunnel as well.
> >
> > It looks though that this change would need to be added to any
> > tunnel device using dst_cache (vxlan, geneve, gre, ...).  
> 
> Yes.  Meanwhile I tested your patch and it works for me too.
> As your patch is shorter and ipv4/ipv6 seem to take care of refcount
> put just fine I think your patch is the right way to go.
> 
> The xfrm_dst size incrase isn't much of a big deal, there is ample of
> padding at the end so it will still be allocated from same slab.
> 
> We could reduce num_pols and num_xfrms to u8, which creates a 16 bit
> hole, then store the cpu number instead of a list pointer.
> 
> This would limit growth to 16 instead of 24.
> 
> But, as I said, i do not think its a big deal.
> 
> > I'm wondering - non-xfrm dsts are already correctly invalidated,
> > so do you think it makes sense to invalidate caches for devices that
> > have no xfrm dsts? or maybe I didn't understand the suggestion?  
> 
> See above, I think your patch is the way to go.

Ok, thanks. Will submit a formal patch.

Eyal.